/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package guitaramplifier;

import java.util.*;
import java.io.*;

/**
 *
 * @author gsc35
 */
public class Amplifier 
{
   public int masterVolume;
   public Hashtable<String, Channel> channels;
   public ArrayList<String> ampModels;
   public ArrayList<String> cabinetModels;
   public ArrayList<String> delayEffects;
   public ArrayList<String> normalEffects;
   public Channel current;
   
   public Amplifier()
   {
       channels = new Hashtable<String, Channel>();
       
       Channel a = new Channel("A");
       Channel b = new Channel("B");
       Channel c = new Channel("C");
       Channel d = new Channel("D");
       channels.put(a.getName(),a);
       channels.put(b.getName(),b);
       channels.put(c.getName(),c);
       channels.put(d.getName(),d);
       
       current = channels.get("A");
       this.masterVolume = 1;
       
       ampModels = new ArrayList<String>();
       ampModels.add("Gibson Explorer");
       ampModels.add("Supro S6616");
       ampModels.add("Soldano SLO-100 Head");
       
       cabinetModels = new ArrayList<String>();
       cabinetModels.add("4x12 Mesa Boogie V30");
       
       delayEffects = new ArrayList<String>();
       delayEffects.add("Ping Pong Delay");
       delayEffects.add("None");
       
       normalEffects = new ArrayList<String>();
       normalEffects.add("Chorus");
       normalEffects.add("Tremelo");
       
       
       
   }
   
   public ArrayList<String> getAmpModels()
   {
       return ampModels;
   }
   
   public Hashtable<String, Channel> getChannels()
   {
       return channels;
   }
        
   
   public boolean addChannel(String channelName)
   {
       Channel channel = new Channel(channelName);
       boolean noSuchChannel = true;
       boolean channelAdded = false;
       
       HashSet keySet = new HashSet(getChannels().keySet());
       Iterator i = keySet.iterator();
       String name;
       while (i.hasNext())
       {
            name = (String) i.next();
            if (!name.equalsIgnoreCase(channelName))
            {
                noSuchChannel = true;
            }
            else
            {
                noSuchChannel = false;
                break;
            }
       }
       
       if (noSuchChannel)
       {
            channels.put(channel.getName(), channel);
            channelAdded = true;
       }
       
       
       return channelAdded;
       
   }
   
   public void setCurrentChannel(String name)
   {
       name = name.toUpperCase();
       if (channels.get(name) != null) 
       {
           current = channels.get(name);
       }
   }
   
   public String getCurrentChannel()
   {
       return current.getName();
   }
   
   public void setMasterVolume(int masterVolume)
   {
       this.masterVolume = masterVolume;
   }
   
   public int getMasterVolume()
   {
       return masterVolume;
   }
   
    public void saveSettings()
   {
       current.saveSettings();
   }
   
   //AMP MODEL
   public boolean addNewAmpModel(String newAmpModel)
   {
       boolean ampModelAdded = false;
       if (!ampModels.contains(newAmpModel))
       {
           ampModels.add(newAmpModel);
           ampModelAdded = true;
       }
       return ampModelAdded;
   }
    
   public boolean setAmpModel(String ampModel)
   {
       boolean isSet = false;
       if (ampModels.contains(ampModel))
       {
           current.setAmpModel(ampModel);
           isSet = true;
       }
       return isSet;  
   }
   
   public String getAmpModelName()
   {
       return current.getAmpModelName();
   }
    
   public int getAmpModelDrive()
   {
       return current.getAmpModelDrive();
   }
   
   public int getAmpModelBass()
   {
       return current.getAmpModelBass();
   }
   
   public int getAmpModelMid()
   {
       return current.getAmpModelMid();
   }
   
   public int getAmpModelTreble()
   {
       return current.getAmpModelTreble();
   }
   
   public int getAmpModelPresence()
   {
       return current.getAmpModelPresence();     
   }
   
   public int getAmpModelVolume()
   {
       return current.getAmpModelVolume();
   }
   
   public int getAmpModelReverb()
   {
       return current.getAmpModelReverb();
   }
   
   public void setAmpModelDrive(int drive)
   {
        current.setAmpModelDrive(drive);
   }   
    
   public void setAmpModelBass(int bass)
   {
       current.setAmpModelBass(bass);
   }
   
   public void setAmpModelMid(int mid)
   {
       current.setAmpModelMid(mid);
   }
    
   public void setAmpModelTreble(int treble)
   {
       current.setAmpModelTreble(treble);
   }
    
   public void setAmpModelPresence(int presence)
   {
       current.setAmpModelPresence(presence);
   }
    
   public void setAmpModelVolume(int volume)
   {
       current.setAmpModelVolume(volume);
   }
   
   public void setAmpModelReverb(int reverb)
   {
       current.setAmpModelReverb(reverb);
   }
   
   
   //CABINET MODEL
   public ArrayList<String> getCabinetModels()
   {
       return cabinetModels;
   }
   
   public boolean addNewCabinetModel(String newCabModel)
   {
       boolean cabModelAdded = false;
       if (!cabinetModels.contains(newCabModel))
       {
           cabinetModels.add(newCabModel);
           cabModelAdded = true;
       }
       return cabModelAdded;
   }
   
   public boolean setCabinetModel(String cabinetModel)
   {
       boolean isSet = false;
       if (cabinetModels.contains(cabinetModel))
       {
           current.setCabinetModel(cabinetModel);
           isSet = true;
       }
       return isSet;
   }
   
     public String getCabinetModelName()
    {
        return current.getCabinetModelName();
    }
  
   
   //DELAY EFFECT
   public ArrayList<String> getDelayEffects()
   {
       return delayEffects;
   }
     
   public boolean addNewDelayEffect(String newDelayEffect)
   {
       boolean delayEffectAdded = false;
       if (!delayEffects.contains(newDelayEffect))
       {
           delayEffects.add(newDelayEffect);
           delayEffectAdded = true;
       }
       return delayEffectAdded;
   }
     
    public boolean setDelayEffect(String delayName)
    { 
       boolean isSet = false;
       if (delayEffects.contains(delayName))
       { 
           current.setDelayEffect(delayName, 1, 120);
           isSet = true;
       }
       return isSet; 
    }
    
    public String getDelayEffectName()
    {
        return current.getDelayEffectName();
    }
    
    public int getDelayEffectTempo()
    {
        return current.getDelayEffectTempo();
    }
    
     public void setDelayEffectTempo(int tempo)
    {
        current.setDelayEffectTempo(tempo);
    }
    
     public int getDelayEffectIntensity()
    {
        return current.getDelayEffectIntensity();
    }
    
    public void setDelayEffectIntensity(int intensity)
    {
        current.setDelayEffectIntensity(intensity);
    }
    
    
    //NORMAL EFFECT
    public ArrayList<String> getNormalEffects()
    {
        return normalEffects;
    }
    
    public boolean addNewNormalEffect(String newNormalEffect)
   {
       boolean normalEffectAdded = false;
       if (!normalEffects.contains(newNormalEffect))
       {
           normalEffects.add(newNormalEffect);
           normalEffectAdded = true;
       }
       return normalEffectAdded;
   }
    
    public boolean setNormalEffect(String effect)
    {
        boolean isSet = false;
       if (normalEffects.contains(effect))
       { 
           current.setNormalEffect(effect, 1);
           isSet = true;
       }
       return isSet;
    }
    
    public String getNormalEffectName()
    {
        return current.getNormalEffectName();
    }
    
    public int getNormalEffectIntensity()
    {
        return current.getNormalEffectIntensity();
    }
    
    public void setNormalEffectIntensity(int intensity)
    {
        current.setNormalEffectIntensity(intensity);
    }
    
    //SOUND GATE AND COMPRESSOR
    public void setSoundGateStatus(String status)
    {
        current.setSoundGateStatus(status);
    }
    
    public boolean getSoundGateStatus()
    {
        return current.getSoundGateStatus();
    }
    
    public void setCompressorStatus(String status)
    {
        current.setCompressorStatus(status);
    }
    
    public boolean getCompressorStatus()
    {
        return current.getCompressorStatus();
    }
    
   public static void main(String[] args) {
        // TODO code application logic here
        Amplifier cp = new Amplifier();
        int value = 0;
        System.out.print("Enter your commands: ");
        String command = "";
        //open up standard input
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        while (!command.equalsIgnoreCase("exit"))
        {
            //read channel from command-line
            try 
            {
                command = br.readLine();
                
            }
            catch (IOException ioe)
            {
                System.out.println("Error!");
                System.exit(1);
            }
            
            //channel selection handling
            if(command.startsWith("select channel"))
            {
                channelSelectionHandling(command, cp);
            }
            
            //display current settings
            if(command.startsWith("show settings"))
            {
                showSettings(cp);
            }

            //amp selection handling
            if (command.startsWith("show amps"))
            {
                int i = 1;
                for (String s : cp.getAmpModels())
                {
                    System.out.printf("%d. " + s + "\n", i);
                    i++;
                }
                System.out.print("\n"); 
            }
            
            if (command.startsWith("select amp"))
            {
               System.out.print("Select your choice by number: ");
               try
               {
                   command = br.readLine();
               }
               catch (IOException ioe)
               {
                   System.out.println("Error!");
                   System.exit(1);
               }
               selectAmp(command, cp);
            }
            
            if (command.startsWith("show cabinets"))
            {
                int i  = 1;
                for (String s : cp.getCabinetModels())
                {
                    System.out.printf("%d. " + s + "\n", i);
                    i++;
                }
                System.out.print("\n"); 
            }
            
            if (command.startsWith("select cabinet"))
            {
               System.out.print("Select your choice by number: ");
               try
               {
                   command = br.readLine();
               }
               catch (IOException ioe)
               {
                   System.out.println("Error!");
                   System.exit(1);
               }
               selectCabinet(command, cp);
            }
            
            //delay effect selection
            if (command.startsWith("show delay effects"))
            {
                int i = 1;
                for (String s : cp.getDelayEffects())
                {
                    System.out.printf("%d. " + s + "\n", i);
                    i++;
                }
                System.out.print("\n");   
            }
            
            if (command.startsWith("select delay effect"))
            {
                System.out.print("Select your choice by number: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                selectDelay(command, cp);
            }
            
            if (command.startsWith("show normal effects"))
            {
                int i = 1;
                for (String s : cp.getNormalEffects())
                {
                    System.out.printf("%d. " + s + "\n", i);
                    i++;
                }
                System.out.print("\n");   
            }
            
            if (command.startsWith("select normal effect"))
            {
                System.out.print("Select your choice by number: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                selectNormalEffect(command, cp);
            }
            
            //saving the current settings to a channel
            if (command.startsWith("save settings"))
            {
                cp.saveSettings();
                System.out.println("\n");
            }
            
            if (command.startsWith("set amp drive"))
            {
                command = command.substring(command.lastIndexOf(" "));
                value = Integer.parseInt(command);
                cp.setAmpModelDrive(value);
            }
            
            if (command.startsWith("set amp bass"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelBass(value);
            }
            
            if (command.startsWith("set amp mid"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelMid(value);
            }
            
            if (command.startsWith("set amp treble"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelTreble(value);
            }
            
            if (command.startsWith("set amp presence"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelPresence(value);
            }
            
            if (command.startsWith("set amp volume"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelVolume(value);
            }
            
            if (command.startsWith("set amp reverb"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                value = Integer.parseInt(command);
                cp.setAmpModelReverb(value);
            }
            
            if (command.startsWith("set amp soundgate"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                
                cp.setSoundGateStatus(command);
            }
            
            if (command.startsWith("set amp compressor"))
            {
                command = command.substring(command.lastIndexOf(" ") + 1);
                
                cp.setSoundGateStatus(command);
            }
            
            if (command.startsWith("set delay intensity"))
            {
                command = command.substring(command.lastIndexOf(" "));
                value = Integer.parseInt(command);
                cp.setDelayEffectIntensity(value);
            }
            
            if (command.startsWith("set delay tempo"))
            {
                command = command.substring(command.lastIndexOf(" "));
                value = Integer.parseInt(command);
                cp.setDelayEffectTempo(value);
            }
            
            if (command.startsWith("set effect intensity"))
            {
                command = command.substring(command.lastIndexOf(" "));
                value = Integer.parseInt(command);
                cp.setNormalEffectIntensity(value);
            }
            
            if (command.startsWith("show channels"))
            {
                HashSet<String> keySet = new HashSet(cp.getChannels().keySet());
                Iterator i = keySet.iterator();
                while (i.hasNext())
                {
                    System.out.println("Channel " + i.next());
                }
                System.out.println("\n");
                 
            }
            
            //add a new channel
            if (command.startsWith("add new channel"))
            {
                System.out.print("Enter a non-existing channel ID: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                
                addChannel(command, cp);
            }
            
            if (command.startsWith("add new delay"))
            {
                System.out.print("Enter a non-existing delay name: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                
                addNewDelay(command, cp);
            }
            
            if (command.startsWith("add new amp model"))
            {
                System.out.print("Enter a non-existing amp model name: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                
                addNewAmp(command, cp);
            }
            
            if (command.startsWith("add new cabinet model"))
            {
                System.out.print("Enter a non-existing cabinet model name: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                
                addNewCabinet(command, cp);
            }
            
            if (command.startsWith("add new effect"))
            {
                System.out.print("Enter a non-existing effect name: ");
                try
                {
                    command = br.readLine();
                }
                catch (IOException ioe)
                {
                    System.out.println("Error!");
                    System.exit(1);
                }
                
                addNewEffect(command, cp);
            }
        }
    }
   
   public static void channelSelectionHandling(String command, Amplifier cp)
   {
        String channel = "";
        int length = command.length();
        channel = command.substring(length-1, length);
        cp.setCurrentChannel(channel);
        channel = cp.getCurrentChannel();
        System.out.println("Current channel is: " + channel + "\n");           
   }
   
   public static void showSettings(Amplifier cp)
   {
       System.out.println("Amp: " + cp.getAmpModelName());
       System.out.println("    Drive: " + cp.getAmpModelDrive());
       System.out.println("    Bass: " + cp.getAmpModelBass());
       System.out.println("    Mid: " + cp.getAmpModelMid());
       System.out.println("    Treble: " + cp.getAmpModelTreble());
       System.out.println("    Presence: " + cp.getAmpModelPresence());
       System.out.println("    Volume: " + cp.getAmpModelVolume());
       System.out.println("    Reverb: " + cp.getAmpModelReverb());
       
       if (cp.getCompressorStatus() == true)
       {
           System.out.println("    Compressor: On");
       }
       else
       {
           System.out.println("    Compressor: Off");
       }
       
       if (cp.getSoundGateStatus() == true)
       {
           System.out.println("    Sound Gate: On");
       }
       else
       {
           System.out.println("    Sound Gate: Off");
       }
       System.out.println("\n");
        
       System.out.println("Cabinet: " + cp.getCabinetModelName());
                
       if (cp.getDelayEffectName().equalsIgnoreCase("NoDelay"))
       {
           System.out.println("Delay Effect: None");
       } 
       else
       {
           System.out.println("Delay Effect: " + cp.getDelayEffectName());
           System.out.println("    Delay Intensity: " + cp.getDelayEffectIntensity());
           System.out.println("    Delay Tempo: " + cp.getDelayEffectTempo());
           System.out.println("\n");
       }
       
       
       if (cp.getNormalEffectName().equalsIgnoreCase("NoEffect"))
       {
           System.out.println("Normal Effect: None");
       } 
       else
       {
           System.out.println("Normal Effect: " + cp.getNormalEffectName());
           System.out.println("    Normal Effect Intensity: " + cp.getNormalEffectIntensity());
           System.out.println("\n");
       }
       
   }
   
   public static void addChannel(String command, Amplifier cp)
   {
       if (cp.addChannel(command) == true)
       {    
           System.out.println("New channel created\n");
       }
       else
       {
           System.out.println("Sorry, that channel name is taken\n");
       }
  }
   
   public static void addNewDelay(String command, Amplifier cp)
   {
       if (cp.addNewDelayEffect(command) == true)
       {    
           System.out.println("New delay created\n");
       }
       else
       {
           System.out.println("Sorry, that delay already exists\n");
       }
  }
   
   public static void addNewAmp(String command, Amplifier cp)
   {
       if (cp.addNewAmpModel(command) == true)
       {    
           System.out.println("New amp model created\n");
       }
       else
       {
           System.out.println("Sorry, that amp model already exists\n");
       }
  }
   
   public static void addNewCabinet(String command, Amplifier cp)
   {
       if (cp.addNewCabinetModel(command) == true)
       {    
           System.out.println("New cabinet model created\n");
       }
       else
       {
           System.out.println("Sorry, that cabinet model already exists\n");
       }
  }
   
   
   
   public static void addNewEffect(String command, Amplifier cp)
   {
       if (cp.addNewNormalEffect(command) == true)
       {    
           System.out.println("New effect created\n");
       }
       else
       {
           System.out.println("Sorry, that effect already exists\n");
       }
  }
   
   public static void selectAmp(String command, Amplifier cp)
   {
       
       int j = Integer.parseInt(command) - 1;
       String ampChoice = cp.getAmpModels().get(j);

       if (cp.setAmpModel(ampChoice) == true)
       {    
           System.out.println("Current Amp Model is: " + ampChoice + "\n");
       }
       else
       {
           System.out.println("That amp doesn't exist");
       }
  }
   
  public static void selectCabinet(String command, Amplifier cp)
   {
       
       int j = Integer.parseInt(command) - 1;
       String cabChoice = cp.getCabinetModels().get(j);

       if (cp.setCabinetModel(cabChoice) == true)
       {    
           System.out.println("Current Cabinet Model is: " + cabChoice + "\n");
       }
       else
       {
           System.out.println("That cabinet doesn't exist");
       }
  }
   
  public static void selectDelay(String command, Amplifier cp)
  {
      int j = Integer.parseInt(command) - 1;
      String delayChoice = cp.getDelayEffects().get(j);
                
      if (cp.setDelayEffect(delayChoice) == true)
      {    
            System.out.println("Current Delay Effect is: " + delayChoice + "\n");
      }
      else
      {
            System.out.println("That delay doesn't exist");
      }
  }
  
  public static void selectNormalEffect(String command, Amplifier cp)
  {
      int j = Integer.parseInt(command) - 1;
      String effectChoice = cp.getNormalEffects().get(j);
                
      if (cp.setNormalEffect(effectChoice) == true)
      {    
            System.out.println("Current Normal Effect is: " + effectChoice + "\n");
      }
      else
      {
            System.out.println("That effect doesn't exist");
      }
  }
   
}
