/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package guitaramplifier;

/**
 *
 * @author gsc35
 */
public class Channel 
{
    public String name;
    public Settings saved;
    public Settings current;
    
    public Channel(String name)
    {
        this.name = name;
        saved = new Settings();
        current = new Settings();
    }

    public String getName() 
    {
        return name;
    }
    
    public void saveSettings()
    {
        saved.setAmpModel(current.getAmpModelName());
        saved.setAmpModelDrive(current.getAmpModelDrive());
        saved.setAmpModelBass(current.getAmpModelBass());
        saved.setAmpModelMid(current.getAmpModelMid());
        saved.setAmpModelTreble(current.getAmpModelTreble());
        saved.setAmpModelPresence(current.getAmpModelPresence());
        saved.setAmpModelVolume(current.getAmpModelVolume());
        saved.setAmpModelReverb(current.getAmpModelReverb());
        
        if (current.getSoundGateStatus() == true)
        {
            saved.setSoundGateStatus("On");
        }
        else
        {
            saved.setSoundGateStatus("Off");
        }
        
        if (current.getCompressorStatus() == true)
        {
            saved.setCompressorStatus("On");
        }
        else
        {
            saved.setCompressorStatus("Off");
        }
        
        saved.setCabinetModel(current.getCabinetModelName());
        
        saved.setDelayEffect(current.getDelayEffectName(), 
                             current.getDelayEffectIntensity(), 
                             current.getDelayEffectTempo(), false);
        
        saved.setNormalEffect(current.getNormalEffectName(), 
                              current.getNormalEffectIntensity(), false);
        
    }
    
    //AMP MODEL
    public void setAmpModel(String ampModel)
    {
        current.setAmpModel(ampModel);
    }
    
    public String getAmpModelName()
    {
        return saved.getAmpModelName();
    }
    
    public int getAmpModelDrive()
    {
        return saved.getAmpModelDrive();
    }
    
    public int getAmpModelBass()
    {
        return saved.getAmpModelBass();
    }
    
    public int getAmpModelMid()
    {
        return saved.getAmpModelMid();
    }
    
    public int getAmpModelTreble()
    {
        return saved.getAmpModelTreble();
    }
    
    public int getAmpModelPresence()
    {
        return saved.getAmpModelPresence();     
    }
    
    public int getAmpModelVolume()
    {
        return saved.getAmpModelVolume();
    }
    
    public int getAmpModelReverb()
    {
        return saved.getAmpModelReverb();
    }
    
    public void setAmpModelDrive(int drive)
    {
        current.setAmpModelDrive(drive);
    }   
    
    public void setAmpModelBass(int bass)
    {
        current.setAmpModelBass(bass);
    }
    
    public void setAmpModelMid(int mid)
    {
        current.setAmpModelMid(mid);
    }
    
    public void setAmpModelTreble(int treble)
    {
        current.setAmpModelTreble(treble);
    }
    
    public void setAmpModelPresence(int presence)
    {
        current.setAmpModelPresence(presence);
    }
    
    public void setAmpModelVolume(int volume)
    {
        current.setAmpModelVolume(volume);
    }
    
    public void setAmpModelReverb(int reverb)
    {
        current.setAmpModelReverb(reverb);
    }
    
    
    //CABINET MODEL
    public void setCabinetModel(String cabinetModel)
    {
        current.setCabinetModel(cabinetModel);
    }
    
    public String getCabinetModelName()
    {
        return saved.getCabinetModelName();
    }
    
    //DELAY EFFECT
    public void setDelayEffect(String delayName, int intensity, int tempo)
    {
        current.setDelayEffect(delayName, intensity, tempo, true);
    }
    
    public String getDelayEffectName()
    {
        return saved.getDelayEffectName();
    }
    
    public int getDelayEffectTempo()
    {
        return saved.getDelayEffectTempo();
    }
    
     public void setDelayEffectTempo(int tempo)
    {
        current.setDelayEffectTempo(tempo);
    }
    
     public int getDelayEffectIntensity()
    {
        return saved.getDelayEffectIntensity();
    }
    
    public void setDelayEffectIntensity(int intensity)
    {
        current.setDelayEffectIntensity(intensity);
    }
    
    
    //NORMAL EFFECT
    public void setNormalEffect(String effect, int intensity)
    {
        current.setNormalEffect(effect, intensity, true);
    }
    
    public String getNormalEffectName()
    {
        return saved.getNormalEffectName();
    }
    
    public int getNormalEffectIntensity()
    {
        return saved.getNormalEffectIntensity();
    }
    
    public void setNormalEffectIntensity(int intensity)
    {
        current.setNormalEffectIntensity(intensity);
    }
    
    //SOUND GATE AND COMPRESSOR
    public void setSoundGateStatus(String status)
    {
        current.setSoundGateStatus(status);
    }
    
    public boolean getSoundGateStatus()
    {
        return current.getSoundGateStatus();
    }
    
    public void setCompressorStatus(String status)
    {
        current.setCompressorStatus(status);
    }
    
    public boolean getCompressorStatus()
    {
        return current.getCompressorStatus();
    }
    
}
