/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package guitaramplifier;

/**
 *
 * @author gsc35
 */
public class Settings implements Cloneable
{
    private AmpModel amp;
    public CabinetModel cabinet;
    public DelayEffect delay;
    public NormalEffect effect;
    
    public Settings()
    {
        amp = new AmpModel("Line 6 21st Century Clean");
        cabinet = new CabinetModel("None");
        delay = new NoDelay("NoDelay");
        effect = new Chorus("Chorus", 1);
    }

            
    
    //AMP MODEL
    public void setAmpModel(String ampName)
    {
        this.amp = new AmpModel(ampName);
    }
    
    public String getAmpModelName()
    {
        return amp.getName();
    }
    
    public int getAmpModelDrive()
    {
        return amp.getDrive();
    }
    
    public int getAmpModelBass()
    {
        return amp.getBass();
    }
    
    public int getAmpModelMid()
    {
        return amp.getMid();
    }
    
    public int getAmpModelTreble()
    {
        return amp.getTreble();
    }
    
    public int getAmpModelPresence()
    {
        return amp.getPresence();     
    }
    
    public int getAmpModelVolume()
    {
        return amp.getVolume();
    }
    
    public int getAmpModelReverb()
    {
        return amp.getReverb();
    }
    
    public void setAmpModelDrive(int drive)
    {
        amp.setDrive(drive);
    }   
    
    public void setAmpModelBass(int bass)
    {
        amp.setBass(bass);
    }
    
    public void setAmpModelMid(int mid)
    {
        amp.setMid(mid);
    }
    
    public void setAmpModelTreble(int treble)
    {
        amp.setTreble(treble);
    }
    
    public void setAmpModelPresence(int presence)
    {
        amp.setPresence(presence);
    }
    
    public void setAmpModelVolume(int volume)
    {
        amp.setVolume(volume);
    }
    
    public void setAmpModelReverb(int reverb)
    {
        amp.setReverb(reverb);
    }
    
    //CABINET MODEL
    public void setCabinetModel(String cabinetName)
    {
        this.cabinet = new CabinetModel(cabinetName);
    }
    
    public String getCabinetModelName()
    {
        return cabinet.getName();
    }
    
    //DELAY EFFECT - using if statements for strategy pattern
     public void setDelayEffect(String delayName, int intensity, int tempo, boolean output)
     {
        if (delayName.equalsIgnoreCase("Ping Pong Delay"))
        {
            delay = new PingPongDelay(delayName, intensity, tempo);
            if (output)
            {
                delay.processSignal();
            }
        }
        if(delayName.equalsIgnoreCase("None"))
        {
            delay = new NoDelay(delayName);
            if (output)
            {
                delay.processSignal();
            }
        }
        
     }
     
    public String getDelayEffectName()
    {
        return delay.getEffectName();
    }
    
    public int getDelayEffectTempo()
    {
        return delay.getTempo();
    }
    
    public void setDelayEffectTempo(int tempo)
    {
        delay.setTempo(tempo);
    }
    
    public int getDelayEffectIntensity()
    {
        return delay.getIntensity();
    }
    
    public void setDelayEffectIntensity(int intensity)
    {
        delay.setIntensity(intensity);
    }
    
    
    
    //NORMAL EFFECT
    public void setNormalEffect(String effectName, int intensity, boolean output)
    {
        if (effectName.equalsIgnoreCase("Chorus"))
        {
            this.effect = new Chorus(effectName, intensity);
            if (output)
            {
                effect.processSignal();
            }
        }
        if (effectName.equalsIgnoreCase("Tremelo"))
        {
            this.effect = new Tremelo(effectName, intensity);
            if (output)
            {
                effect.processSignal();
            }
        }
        if(effectName.equalsIgnoreCase("None"))
        {
            effect = new NoEffect(effectName);
            if (output)
            {
                effect.processSignal();
            }
        }
    }
    
    public String getNormalEffectName()
    {
        return effect.getEffectName();
    }
    
    public int getNormalEffectIntensity()
    {
        return effect.getIntensity();
    }
    
    public void setNormalEffectIntensity(int intensity)
    {
        effect.setIntensity(intensity);
    }
    
    //SOUND GATE AND COMPRESSOR
    public void setSoundGateStatus(String status)
    {
        amp.setSoundGateStatus(status);
    }
    
    public boolean getSoundGateStatus()
    {
        return amp.getSoundGateStatus();
    }
    
    public void setCompressorStatus(String status)
    {
        amp.setCompressorStatus(status);
    }
    
    public boolean getCompressorStatus()
    {
        return amp.getCompressorStatus();
    }
       
}
